diff --git a/src/main/java/net/minecraft/core/item/ItemDye.java b/src/main/java/net/minecraft/core/item/DyeItem.java
similarity index 70%
rename from src/main/java/net/minecraft/core/item/ItemDye.java
rename to src/main/java/net/minecraft/core/item/DyeItem.java
index 59af2e1dc..b05a59dca 100644
--- a/src/main/java/net/minecraft/core/item/ItemDye.java
+++ b/src/main/java/net/minecraft/core/item/DyeItem.java
@@ -2,25 +2,26 @@ package net.minecraft.core.item;
 
 
 import net.minecraft.core.block.Block;
-import net.minecraft.core.block.BlockWool;
-import net.minecraft.core.block.entity.TileEntitySign;
+import net.minecraft.core.block.Blocks;
+import net.minecraft.core.block.entity.SignBlockEntity;
 import net.minecraft.core.block.tag.BlockTags;
-import net.minecraft.core.entity.EntityLiving;
-import net.minecraft.core.entity.animal.EntitySheep;
-import net.minecraft.core.entity.player.EntityPlayer;
+import net.minecraft.core.entity.Mob;
+import net.minecraft.core.entity.animal.SheepMob;
+import net.minecraft.core.entity.player.Player;
 import net.minecraft.core.net.command.TextFormatting;
+import net.minecraft.core.util.helper.DyeColor;
 import net.minecraft.core.util.helper.Side;
 import net.minecraft.core.world.World;
 import net.minecraft.core.world.biome.Biome;
 import net.minecraft.core.world.biome.Biomes;
 import net.minecraft.core.world.type.WorldTypes;
 
-public class ItemDye extends Item
+public class DyeItem extends Item
 {
 
-    public ItemDye(String name, int id)
+    public DyeItem(String name, String namespaceId, int id)
     {
-        super(name, id);
+        super(name, namespaceId, id);
         setHasSubtypes(true);
         setMaxDamage(0);
     }
@@ -28,18 +29,18 @@ public class ItemDye extends Item
     @Override
     public String getLanguageKey(ItemStack itemstack)
     {
-        return super.getKey() + "." + dyeColors[itemstack.getMetadata()];
+        return super.getKey() + "." + DyeColor.colorFromItemMeta(itemstack.getMetadata()).colorID;
     }
 
     @Override
-    public boolean onUseItemOnBlock(ItemStack itemstack, EntityPlayer entityplayer, World world, int blockX, int blockY, int blockZ, Side side, double xPlaced, double yPlaced)
+    public boolean onUseItemOnBlock(ItemStack itemstack, Player entityplayer, World world, int blockX, int blockY, int blockZ, Side side, double xPlaced, double yPlaced)
     {
-        if (world.getBlockId(blockX, blockY, blockZ) == Block.signPostPlanksOak.id || world.getBlockId(blockX, blockY, blockZ) == Block.signWallPlanksOak.id)
+        if (world.getBlockId(blockX, blockY, blockZ) == Blocks.SIGN_POST_PLANKS_OAK.id || world.getBlockId(blockX, blockY, blockZ) == Blocks.SIGN_WALL_PLANKS_OAK.id)
         {
-            TileEntitySign sign = (TileEntitySign) world.getBlockTileEntity(blockX, blockY, blockZ);
-            if ((15 - itemstack.getMetadata()) != sign.getColor().id)
+            SignBlockEntity sign = (SignBlockEntity) world.getBlockEntity(blockX, blockY, blockZ);
+            if ((DyeColor.WHITE.itemMeta - itemstack.getMetadata()) != sign.getColor().id)
             {
-                sign.setColor(TextFormatting.get(15 - itemstack.getMetadata()));
+                sign.setColor(TextFormatting.get(DyeColor.WHITE.itemMeta - itemstack.getMetadata()));
                 if (entityplayer.getGamemode().consumeBlocks())
                 {
                     itemstack.stackSize--;
@@ -48,7 +49,7 @@ public class ItemDye extends Item
             }
             return false;
         }
-        if(itemstack.getMetadata() == 15)
+        if(itemstack.getMetadata() == DyeColor.WHITE.itemMeta)
         {
             int id = world.getBlockId(blockX, blockY, blockZ);
             Block block = Block.blocksList[id];
@@ -57,14 +58,14 @@ public class ItemDye extends Item
                    return true;
                }
             }
-            if(id == Block.dirt.id)
+            if(id == Blocks.DIRT.id)
             {
                 if(!world.isClientSide)
                 {
                     if(Block.lightBlock[world.getBlockId(blockX, blockY + 1, blockZ)] <= 2) {
-                    	int grass = Block.grass.id;
+                    	int grass = Blocks.GRASS.id;
                     	if(world.dimensionData.getWorldType() == WorldTypes.OVERWORLD_RETRO) {
-                    		grass = Block.grassRetro.id;
+                    		grass = Blocks.GRASS_RETRO.id;
                     	}
                         world.setBlockWithNotify(blockX, blockY, blockZ, grass);
                         if (entityplayer.getGamemode().consumeBlocks())
@@ -75,12 +76,12 @@ public class ItemDye extends Item
                 }
                 return true;
             }
-            if(id == Block.dirtScorched.id)
+            if(id == Blocks.DIRT_SCORCHED.id)
             {
                 if (!world.isClientSide)
                 {
                     if(Block.lightBlock[world.getBlockId(blockX, blockY + 1, blockZ)] <= 2) {
-                        int grass = Block.grassScorched.id;
+                        int grass = Blocks.GRASS_SCORCHED.id;
                         world.setBlockWithNotify(blockX, blockY, blockZ, grass);
                         if (entityplayer.getGamemode().consumeBlocks())
                         {
@@ -123,27 +124,27 @@ label0:
                         }
                         if(itemRand.nextInt(10) != 0)
                         {
-                            if(world.getBlockId(k1, l1-1, i2) == Block.dirtScorched.id ||
-                                    world.getBlockId(k1, l1-1, i2) == Block.dirtScorchedRich.id)
-                                world.setBlockWithNotify(k1, l1, i2, Block.spinifex.id);
+                            if(world.getBlockId(k1, l1-1, i2) == Blocks.DIRT_SCORCHED.id ||
+                                    world.getBlockId(k1, l1-1, i2) == Blocks.DIRT_SCORCHED_RICH.id)
+                                world.setBlockWithNotify(k1, l1, i2, Blocks.SPINIFEX.id);
                             else
-                                world.setBlockWithNotify(k1, l1, i2, Block.tallgrass.id);
+                                world.setBlockWithNotify(k1, l1, i2, Blocks.TALLGRASS.id);
                             continue;
                         }
                         int r = itemRand.nextInt(12);
                         Biome biome = world.getBlockBiome(k1, l1, i2);
                         if (r < 1){
-                            world.setBlockWithNotify(k1, l1, i2, Block.flowerYellow.id);
+                            world.setBlockWithNotify(k1, l1, i2, Blocks.FLOWER_YELLOW.id);
                         } else if (r < 2) {
-                            world.setBlockWithNotify(k1, l1, i2, Block.flowerRed.id);
+                            world.setBlockWithNotify(k1, l1, i2, Blocks.FLOWER_RED.id);
                         } else if (r < 4 && (biome == Biomes.OVERWORLD_BIRCH_FOREST || biome == Biomes.OVERWORLD_SEASONAL_FOREST)) {
-                            world.setBlockWithNotify(k1, l1, i2, Block.flowerPink.id);
+                            world.setBlockWithNotify(k1, l1, i2, Blocks.FLOWER_PINK.id);
                         } else if (r < 6 && (biome == Biomes.OVERWORLD_MEADOW || biome == Biomes.OVERWORLD_BOREAL_FOREST || biome == Biomes.OVERWORLD_SHRUBLAND)) {
-                            world.setBlockWithNotify(k1, l1, i2, Block.flowerPurple.id);
+                            world.setBlockWithNotify(k1, l1, i2, Blocks.FLOWER_PURPLE.id);
                         } else if (r < 8 && (biome == Biomes.OVERWORLD_FOREST || biome == Biomes.OVERWORLD_SWAMPLAND || biome == Biomes.OVERWORLD_RAINFOREST || biome == Biomes.OVERWORLD_GRASSLANDS || biome == Biomes.OVERWORLD_CAATINGA)) {
-                            world.setBlockWithNotify(k1, l1, i2, Block.flowerLightBlue.id);
+                            world.setBlockWithNotify(k1, l1, i2, Blocks.FLOWER_LIGHT_BLUE.id);
                         } else if (r < 10 && (biome == Biomes.OVERWORLD_PLAINS || biome == Biomes.OVERWORLD_GRASSLANDS || biome == Biomes.OVERWORLD_OUTBACK || biome == Biomes.OVERWORLD_OUTBACK_GRASSY)) {
-                            world.setBlockWithNotify(k1, l1, i2, Block.flowerOrange.id);
+                            world.setBlockWithNotify(k1, l1, i2, Blocks.FLOWER_ORANGE.id);
                         }
                     }
                 }
@@ -154,28 +155,19 @@ label0:
     }
 
     @Override
-    public boolean useItemOnEntity(ItemStack itemstack, EntityLiving entityliving, EntityPlayer entityPlayer)
+    public boolean useItemOnEntity(ItemStack itemstack, Mob mob, Player entityPlayer)
     {
-        if(entityliving instanceof EntitySheep)
+        if(mob instanceof SheepMob)
         {
-            EntitySheep entitysheep = (EntitySheep)entityliving;
-            int i = BlockWool.func_21034_c(itemstack.getMetadata());
-            if(entitysheep.getFleeceColor() != i && itemstack.consumeItem(entityPlayer))
+            SheepMob sheepMob = (SheepMob)mob;
+            DyeColor woolColor = DyeColor.colorFromItemMeta(itemstack.getMetadata());
+            if(sheepMob.getFleeceColor() != woolColor && itemstack.consumeItem(entityPlayer))
             {
-                entitysheep.setFleeceColor(i);
+                sheepMob.setFleeceColor(woolColor);
                 return true;
             }
         }
         return false;
     }
 
-    public static final String dyeColors[] = {
-        "black", "red", "green", "brown", "blue", "purple", "cyan", "silver", "gray", "pink", 
-        "lime", "yellow", "lightblue", "magenta", "orange", "white"
-    };
-    public static final int field_31002_bk[] = {
-        0x1e1b1b, 0xb3312c, 0x3b511a, 0x51301a, 0x253192, 0x7b2fbe, 0x287697, 0x287697, 0x434343, 0xd88198, 
-        0x41cd34, 0xdecf2a, 0x6689d3, 0xc354cd, 0xeb8844, 0xf0f0f0
-    };
-
 }
diff --git a/src/main/java/net/minecraft/core/item/ItemEgg.java b/src/main/java/net/minecraft/core/item/EggItem.java
similarity index 55%
rename from src/main/java/net/minecraft/core/item/ItemEgg.java
rename to src/main/java/net/minecraft/core/item/EggItem.java
index 07f939637..4c7771690 100644
--- a/src/main/java/net/minecraft/core/item/ItemEgg.java
+++ b/src/main/java/net/minecraft/core/item/EggItem.java
@@ -1,42 +1,42 @@
 package net.minecraft.core.item;
 
 // Referenced classes of package net.minecraft.src:
-//            Item, ItemStack, World, EntityEgg, 
-//            EntityPlayer
+//            Item, ItemStack, World, EggProjectile,
+//            Player
 
-import net.minecraft.core.entity.projectile.EntityEgg;
-import net.minecraft.core.entity.player.EntityPlayer;
+import net.minecraft.core.entity.projectile.EggProjectile;
+import net.minecraft.core.entity.player.Player;
 import net.minecraft.core.world.World;
 
 import java.util.Random;
 
-public class ItemEgg
+public class EggItem
     extends Item
     implements IDispensable
 {
 
-    public ItemEgg(String name, int id)
+    public EggItem(String name, String namespaceId, int id)
     {
-        super(name, id);
+        super(name, namespaceId, id);
         maxStackSize = 16;
     }
 
     @Override
-    public ItemStack onUseItem(ItemStack itemstack, World world, EntityPlayer entityplayer)
+    public ItemStack onUseItem(ItemStack itemstack, World world, Player entityplayer)
     {
         itemstack.consumeItem(entityplayer);
         world.playSoundAtEntity(entityplayer, entityplayer, "random.bow", 0.5F, 0.4F / (itemRand.nextFloat() * 0.4F + 0.8F));
         if(!world.isClientSide)
         {
-            world.entityJoinedWorld(new EntityEgg(world, entityplayer));
+            world.entityJoinedWorld(new EggProjectile(world, entityplayer));
         }
         return itemstack;
     }
 
     @Override
     public void onDispensed(ItemStack itemStack, World world, double x, double y, double z, int xOffset, int zOffset, Random random) {
-        EntityEgg egg = new EntityEgg(world, x, y, z);
-        egg.setHeading(xOffset, 0.1D, zOffset, 1.1F, 6F);
-        world.entityJoinedWorld(egg);
+        EggProjectile eggProjectile = new EggProjectile(world, x, y, z);
+        eggProjectile.setHeading(xOffset, 0.1D, zOffset, 1.1F, 6F);
+        world.entityJoinedWorld(eggProjectile);
     }
 }
diff --git a/src/main/java/net/minecraft/core/item/ItemBucketEmpty.java b/src/main/java/net/minecraft/core/item/EmptyBucketItem.java
similarity index 71%
rename from src/main/java/net/minecraft/core/item/ItemBucketEmpty.java
rename to src/main/java/net/minecraft/core/item/EmptyBucketItem.java
index a69352c07..db4931281 100644
--- a/src/main/java/net/minecraft/core/item/ItemBucketEmpty.java
+++ b/src/main/java/net/minecraft/core/item/EmptyBucketItem.java
@@ -1,38 +1,38 @@
 package net.minecraft.core.item;
 
 // Referenced classes of package net.minecraft.src:
-//            Item, EntityPlayer, Vec3D, MathHelper,
+//            Item, Player, Vec3D, MathHelper,
 //            World, MovingObjectPosition, EnumMovingObjectType, Material,
-//            ItemStack, WorldProvider, Block, EntityCow
+//            ItemStack, WorldProvider, Block, CowMob
 
-import net.minecraft.core.HitResult;
-import net.minecraft.core.util.phys.Vec3d;
-import net.minecraft.core.entity.player.EntityPlayer;
+import net.minecraft.core.entity.player.Player;
+import net.minecraft.core.util.phys.HitResult;
+import net.minecraft.core.util.phys.Vec3;
 import net.minecraft.core.util.helper.MathHelper;
 import net.minecraft.core.world.World;
 import net.minecraft.core.block.material.Material;
-import net.minecraft.server.entity.player.EntityPlayerMP;
+import net.minecraft.server.entity.player.ServerPlayer;
 
-public class ItemBucketEmpty extends Item
+public class EmptyBucketItem extends Item
 {
 
-    public ItemBucketEmpty(String name, int id)
+    public EmptyBucketItem(String name, String namespaceId, int id)
     {
-        super(name, id);
+        super(name, namespaceId, id);
         maxStackSize = 64;
     }
 
     @Override
-    public ItemStack onUseItem(ItemStack itemstack, World world, EntityPlayer entityplayer)
+    public ItemStack onUseItem(ItemStack itemstack, World world, Player entityplayer)
     {
         float f = 1.0F;
         float f1 = entityplayer.xRotO + (entityplayer.xRot - entityplayer.xRotO) * f;
         float f2 = entityplayer.yRotO + (entityplayer.yRot - entityplayer.yRotO) * f;
         double d = entityplayer.xo + (entityplayer.x - entityplayer.xo) * (double)f;
-        float yOff = entityplayer instanceof EntityPlayerMP ? entityplayer.getHeightOffset() : 0;
+        float yOff = entityplayer instanceof ServerPlayer ? entityplayer.getHeightOffset() : 0;
         double d1 = (entityplayer.yo + (entityplayer.y - entityplayer.yo)) + yOff;
         double d2 = entityplayer.zo + (entityplayer.z - entityplayer.zo) * (double)f;
-        Vec3d vec3d = Vec3d.createVector(d, d1, d2);
+        Vec3 vec3 = Vec3.getTempVec3(d, d1, d2);
         float f3 = MathHelper.cos(-f2 * 0.01745329F - MathHelper.PI);
         float f4 = MathHelper.sin(-f2 * 0.01745329F - MathHelper.PI);
         float f5 = -MathHelper.cos(-f1 * 0.01745329F);
@@ -41,8 +41,8 @@ public class ItemBucketEmpty extends Item
         float f8 = f6;
         float f9 = f3 * f5;
         double reachDistance = entityplayer.getGamemode().getBlockReachDistance();
-        Vec3d vec3d1 = vec3d.addVector((double)f7 * reachDistance, (double)f8 * reachDistance, (double)f9 * reachDistance);
-        HitResult movingobjectposition = world.checkBlockCollisionBetweenPoints(vec3d, vec3d1, true);
+        Vec3 vec31 = vec3.add((double)f7 * reachDistance, (double)f8 * reachDistance, (double)f9 * reachDistance);
+        HitResult movingobjectposition = world.checkBlockCollisionBetweenPoints(vec3, vec31, true);
         if(movingobjectposition == null)
         {
             return itemstack;
@@ -59,14 +59,14 @@ public class ItemBucketEmpty extends Item
 
             else if(world.getBlockMaterial(i, j, k) == Material.water && world.getBlockMetadata(i, j, k) == 0)
             {
-                if(useBucket(entityplayer, new ItemStack(Item.bucketWater))){
+                if(useBucket(entityplayer, new ItemStack(Items.BUCKET_WATER))){
                     world.setBlockWithNotify(i, j, k, 0);
                     entityplayer.swingItem();
                 }
             }
             else if(world.getBlockMaterial(i, j, k) == Material.lava && world.getBlockMetadata(i, j, k) == 0)
             {
-                if(useBucket(entityplayer, new ItemStack(Item.bucketLava))){
+                if(useBucket(entityplayer, new ItemStack(Items.BUCKET_LAVA))){
                     world.setBlockWithNotify(i, j, k, 0);
                     entityplayer.swingItem();
                 }
@@ -75,9 +75,9 @@ public class ItemBucketEmpty extends Item
         return itemstack;
     }
 
-    public static boolean useBucket(EntityPlayer player, ItemStack itemToGive) {
+    public static boolean useBucket(Player player, ItemStack itemToGive) {
         if(player.inventory.getCurrentItem().stackSize <= 1) {
-            player.inventory.setInventorySlotContents(player.inventory.currentItem, itemToGive);
+            player.inventory.setItem(player.inventory.currentItem, itemToGive);
             return true;
         } else {
         	player.inventory.insertItem(itemToGive, true);
diff --git a/src/main/java/net/minecraft/core/item/EndlessQuiverItem.java b/src/main/java/net/minecraft/core/item/EndlessQuiverItem.java
new file mode 100644
index 000000000..544739e60
--- /dev/null
+++ b/src/main/java/net/minecraft/core/item/EndlessQuiverItem.java
@@ -0,0 +1,29 @@
+package net.minecraft.core.item;
+
+
+// Referenced classes of package net.minecraft.src:
+//            Item, Block, BlockLeaves, ItemStack,
+//            Mob
+
+
+import net.minecraft.core.item.material.ArmorMaterial;
+
+public class EndlessQuiverItem extends Item implements IArmorItem
+{
+
+    public EndlessQuiverItem(String name, String namespaceId, int id)
+    {
+        super(name, namespaceId, id);
+        setMaxStackSize(1);
+    }
+
+    @Override
+    public ArmorMaterial getArmorMaterial() {
+        return null;
+    }
+
+    @Override
+    public int getArmorPiece() {
+        return PIECE_CHEST;
+    }
+}
diff --git a/src/main/java/net/minecraft/core/item/ItemFirestriker.java b/src/main/java/net/minecraft/core/item/FireStrikerItem.java
similarity index 66%
rename from src/main/java/net/minecraft/core/item/ItemFirestriker.java
rename to src/main/java/net/minecraft/core/item/FireStrikerItem.java
index 1b56bec82..bfd478a53 100644
--- a/src/main/java/net/minecraft/core/item/ItemFirestriker.java
+++ b/src/main/java/net/minecraft/core/item/FireStrikerItem.java
@@ -1,28 +1,28 @@
 package net.minecraft.core.item;
 
 // Referenced classes of package net.minecraft.src:
-//            Item, World, Block, BlockFire, 
-//            ItemStack, EntityPlayer
+//            Item, World, Block, FireBlock,
+//            ItemStack, Player
 
-import net.minecraft.core.entity.player.EntityPlayer;
+import net.minecraft.core.entity.player.Player;
 import net.minecraft.core.item.material.ToolMaterial;
 import net.minecraft.core.sound.SoundCategory;
 import net.minecraft.core.util.helper.Side;
-import net.minecraft.core.block.Block;
+import net.minecraft.core.block.Blocks;
 import net.minecraft.core.world.World;
 
-public class ItemFirestriker extends Item
+public class FireStrikerItem extends Item
 {
 
-    public ItemFirestriker(String name, int id)
+    public FireStrikerItem(String name, String namespaceId, int id)
     {
-        super(name, id);
+        super(name, namespaceId, id);
         maxStackSize = 1;
         setMaxDamage(ToolMaterial.iron.getDurability()/2);
     }
 
     @Override
-    public boolean onUseItemOnBlock(ItemStack itemstack, EntityPlayer entityplayer, World world, int blockX, int blockY, int blockZ, Side side, double xPlaced, double yPlaced)
+    public boolean onUseItemOnBlock(ItemStack itemstack, Player entityplayer, World world, int blockX, int blockY, int blockZ, Side side, double xPlaced, double yPlaced)
     {
     	blockX += side.getOffsetX();
     	blockY += side.getOffsetY();
@@ -30,7 +30,7 @@ public class ItemFirestriker extends Item
         int i1 = world.getBlockId(blockX, blockY, blockZ);
         if(i1 == 0)
         {
-            if(world.setBlockWithNotify(blockX, blockY, blockZ, Block.fire.id)){
+            if(world.setBlockWithNotify(blockX, blockY, blockZ, Blocks.FIRE.id)){
                 world.playSoundEffect(null, SoundCategory.WORLD_SOUNDS, (double) blockX + 0.5D, (double) blockY + 0.5D, (double) blockZ + 0.5D, "fire.ignite", 1.0F, itemRand.nextFloat() * 0.4F + 0.8F);
                 itemstack.damageItem(1, entityplayer);
                 return true;
diff --git a/src/main/java/net/minecraft/core/item/ItemFishingRod.java b/src/main/java/net/minecraft/core/item/FishingRodItem.java
similarity index 65%
rename from src/main/java/net/minecraft/core/item/ItemFishingRod.java
rename to src/main/java/net/minecraft/core/item/FishingRodItem.java
index 74a2070d7..da9b28e1f 100644
--- a/src/main/java/net/minecraft/core/item/ItemFishingRod.java
+++ b/src/main/java/net/minecraft/core/item/FishingRodItem.java
@@ -1,25 +1,25 @@
 package net.minecraft.core.item;
 
 // Referenced classes of package net.minecraft.src:
-//            Item, EntityPlayer, EntityFish, ItemStack, 
+//            Item, Player, EntityFish, ItemStack,
 //            World
 
-import net.minecraft.core.entity.EntityBobber;
-import net.minecraft.core.entity.player.EntityPlayer;
+import net.minecraft.core.entity.FishingBobberEntity;
+import net.minecraft.core.entity.player.Player;
 import net.minecraft.core.world.World;
 
-public class ItemFishingRod extends Item
+public class FishingRodItem extends Item
 {
 
-    public ItemFishingRod(String name, int id)
+    public FishingRodItem(String name, String namespaceId, int id)
     {
-        super(name, id);
+        super(name, namespaceId, id);
         setMaxDamage(196);
         setMaxStackSize(1);
     }
 
     @Override
-    public ItemStack onUseItem(ItemStack itemstack, World world, EntityPlayer entityplayer)
+    public ItemStack onUseItem(ItemStack itemstack, World world, Player entityplayer)
     {
         if(entityplayer.bobberEntity != null)
         {
@@ -30,7 +30,7 @@ public class ItemFishingRod extends Item
             world.playSoundAtEntity(entityplayer, entityplayer, "random.bow", 0.5F, 0.4F / (itemRand.nextFloat() * 0.4F + 0.8F));
             if(!world.isClientSide)
             {
-                world.entityJoinedWorld(new EntityBobber(world, entityplayer));
+                world.entityJoinedWorld(new FishingBobberEntity(world, entityplayer));
             }
         }
         entityplayer.swingItem();
diff --git a/src/main/java/net/minecraft/core/item/ItemFlag.java b/src/main/java/net/minecraft/core/item/FlagItem.java
similarity index 77%
rename from src/main/java/net/minecraft/core/item/ItemFlag.java
rename to src/main/java/net/minecraft/core/item/FlagItem.java
index dcabac23f..b7b6fe05e 100644
--- a/src/main/java/net/minecraft/core/item/ItemFlag.java
+++ b/src/main/java/net/minecraft/core/item/FlagItem.java
@@ -3,19 +3,19 @@ package net.minecraft.core.item;
 import com.mojang.nbt.CompoundTag;
 import com.mojang.nbt.ListTag;
 
-import net.minecraft.core.block.Block;
-import net.minecraft.core.block.entity.TileEntityFlag;
-import net.minecraft.core.entity.player.EntityPlayer;
+import net.minecraft.core.block.Blocks;
+import net.minecraft.core.block.entity.FlagBlockEntity;
+import net.minecraft.core.entity.player.Player;
 import net.minecraft.core.enums.EnumBlockSoundEffectType;
 import net.minecraft.core.lang.I18n;
 import net.minecraft.core.util.helper.Side;
 import net.minecraft.core.world.World;
 
-public class ItemFlag extends Item
+public class FlagItem extends Item
 {
-    public ItemFlag(String name, int id)
+    public FlagItem(String name, String namespaceId, int id)
     {
-        super(name, id);
+        super(name, namespaceId, id);
         setMaxStackSize(1);
     }
 
@@ -28,11 +28,11 @@ public class ItemFlag extends Item
     }
 
     @Override
-    public boolean onUseItemOnBlock(ItemStack stack, EntityPlayer entityplayer, World world, int blockX, int blockY, int blockZ, Side side, double xPlaced, double yPlaced)
+    public boolean onUseItemOnBlock(ItemStack stack, Player entityplayer, World world, int blockX, int blockY, int blockZ, Side side, double xPlaced, double yPlaced)
     {
         // copy flag data to empty flag
-		if (world.getBlockId(blockX, blockY, blockZ) == Block.flag.id && !entityplayer.isSneaking()) {
-			TileEntityFlag flag = (TileEntityFlag) world.getBlockTileEntity(blockX, blockY, blockZ);
+		if (world.getBlockId(blockX, blockY, blockZ) == Blocks.FLAG.id && !entityplayer.isSneaking()) {
+			FlagBlockEntity flag = (FlagBlockEntity) world.getBlockEntity(blockX, blockY, blockZ);
 			if (flag != null) {
 				CompoundTag flagData = stack.getData().getCompoundOrDefault("FlagData", new CompoundTag());
 				if (hasFlagBeenDrawnOn(stack) && doesFlagContainDyes(stack)) {
@@ -64,16 +64,16 @@ public class ItemFlag extends Item
         if(blockY < 0 || blockY >= world.getHeightBlocks()) {
         	return false;
         }
-        if(!Block.signPostPlanksOak.canPlaceBlockAt(world, blockX, blockY, blockZ))
+        if(!Blocks.SIGN_POST_PLANKS_OAK.canPlaceBlockAt(world, blockX, blockY, blockZ))
         {
             return false;
         }
 
-        world.playBlockSoundEffect(entityplayer, blockX + 0.5F, blockY + 0.5F, blockZ + 0.5F, Block.flag, EnumBlockSoundEffectType.PLACE);
-        world.setBlockAndMetadataWithNotify(blockX, blockY, blockZ, Block.flag.id, 0);
+        world.playBlockSoundEffect(entityplayer, blockX + 0.5F, blockY + 0.5F, blockZ + 0.5F, Blocks.FLAG, EnumBlockSoundEffectType.PLACE);
+        world.setBlockAndMetadataWithNotify(blockX, blockY, blockZ, Blocks.FLAG.id, 0);
         
         stack.consumeItem(entityplayer);
-        TileEntityFlag tileentityflag = (TileEntityFlag) world.getBlockTileEntity(blockX, blockY, blockZ);
+        FlagBlockEntity tileentityflag = (FlagBlockEntity) world.getBlockEntity(blockX, blockY, blockZ);
         if(tileentityflag != null)
         {
             CompoundTag flagData = stack.getData().getCompoundOrDefault("FlagData", null);
diff --git a/src/main/java/net/minecraft/core/item/ItemFood.java b/src/main/java/net/minecraft/core/item/FoodItem.java
similarity index 78%
rename from src/main/java/net/minecraft/core/item/ItemFood.java
rename to src/main/java/net/minecraft/core/item/FoodItem.java
index a4ff0d6c3..a13f3b984 100644
--- a/src/main/java/net/minecraft/core/item/ItemFood.java
+++ b/src/main/java/net/minecraft/core/item/FoodItem.java
@@ -1,17 +1,17 @@
 package net.minecraft.core.item;
 
-import net.minecraft.core.entity.player.EntityPlayer;
+import net.minecraft.core.entity.player.Player;
 import net.minecraft.core.world.World;
 
-public class ItemFood extends Item
+public class FoodItem extends Item
 {
     private final int healAmount;
     private final boolean isWolfsFavoriteMeat;
     private final int ticksPerHeal;
 
-    public ItemFood(String name, int id, int healAmount, int ticksPerHeal, boolean favouriteWolfMeat, int maxStackSize)
+    public FoodItem(String name, String namespaceId, int id, int healAmount, int ticksPerHeal, boolean favouriteWolfMeat, int maxStackSize)
     {
-        super(name, id);
+        super(name, namespaceId, id);
         this.healAmount = healAmount;
         this.ticksPerHeal = ticksPerHeal;
         this.isWolfsFavoriteMeat = favouriteWolfMeat;
@@ -20,7 +20,7 @@ public class ItemFood extends Item
     }
 
     @Override
-    public ItemStack onUseItem(ItemStack itemstack, World world, EntityPlayer entityplayer)
+    public ItemStack onUseItem(ItemStack itemstack, World world, Player entityplayer)
     {
         if(entityplayer.getHealth() < entityplayer.getMaxHealth()
                 && entityplayer.getHealth() + entityplayer.getTotalHealingRemaining() < entityplayer.getMaxHealth()
diff --git a/src/main/java/net/minecraft/core/item/IArmorItem.java b/src/main/java/net/minecraft/core/item/IArmorItem.java
new file mode 100644
index 000000000..fd4f9e21a
--- /dev/null
+++ b/src/main/java/net/minecraft/core/item/IArmorItem.java
@@ -0,0 +1,26 @@
+package net.minecraft.core.item;
+
+import net.minecraft.core.item.material.ArmorMaterial;
+import org.jetbrains.annotations.Nullable;
+
+public interface IArmorItem {
+    int PIECE_HEAD = 0;
+    int PIECE_CHEST = 1;
+    int PIECE_LEGS = 2;
+    int PIECE_BOOTS = 3;
+    int[] ARMOR_PIECE_PROTECTION_VALUES = new int[] {3, 8, 6, 3};
+
+    float[] ARMOR_PIECE_DURABILITY_MODIFIERS = new float[] {0.91f, 1.0f, 0.97f, 0.94f};
+    Item asItem(); // Ensure this has the same signature as Item's Item.asItem
+    @Nullable
+    ArmorMaterial getArmorMaterial();
+    int getArmorPiece();
+    default int armorPieceProtection() {
+        return ARMOR_PIECE_PROTECTION_VALUES[getArmorPiece()];
+    }
+
+    default float getArmorPieceProtectionPercentage() {
+        return armorPieceProtection() / 20.0f;
+    }
+
+}
diff --git a/src/main/java/net/minecraft/core/item/IBonemealable.java b/src/main/java/net/minecraft/core/item/IBonemealable.java
index 0e2bc51ad..936ebb1e8 100644
--- a/src/main/java/net/minecraft/core/item/IBonemealable.java
+++ b/src/main/java/net/minecraft/core/item/IBonemealable.java
@@ -1,9 +1,9 @@
 package net.minecraft.core.item;
 
-import net.minecraft.core.entity.player.EntityPlayer;
+import net.minecraft.core.entity.player.Player;
 import net.minecraft.core.util.helper.Side;
 import net.minecraft.core.world.World;
 
 public interface IBonemealable {
-    boolean onBonemealUsed(ItemStack itemstack, EntityPlayer entityplayer, World world, int blockX, int blockY, int blockZ, Side side, double xPlaced, double yPlaced);
+    boolean onBonemealUsed(ItemStack itemstack, Player entityplayer, World world, int blockX, int blockY, int blockZ, Side side, double xPlaced, double yPlaced);
 }
diff --git a/src/main/java/net/minecraft/core/item/IComplexItem.java b/src/main/java/net/minecraft/core/item/IComplexItem.java
new file mode 100644
index 000000000..f44036c3c
--- /dev/null
+++ b/src/main/java/net/minecraft/core/item/IComplexItem.java
@@ -0,0 +1,15 @@
+package net.minecraft.core.item;
+
+
+// Referenced classes of package net.minecraft.src:
+//            Item
+
+import net.minecraft.core.entity.player.Player;
+import net.minecraft.core.net.packet.Packet;
+import net.minecraft.core.world.World;
+
+public interface IComplexItem
+{
+    Packet sendPacketData(ItemStack itemstack, World world, Player entityplayer);
+
+}
